- Main Page
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# OGRLineString Class Reference

`#include <ogr_geometry.h>`

Inheritance diagram for OGRLineString:

List of all members.

## Public Member Functions
| OGRLineString ()
virtual int | WkbSize () const
virtual OGRErr | importFromWkb (unsigned char *, int=-1)
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *) const
virtual OGRErr | importFromWkt (char **)
virtual OGRErr | exportToWkt (char **ppszDstText) const
virtual int | getDimension () const
virtual OGRGeometry * | clone () const
virtual void | empty ()
virtual void | getEnvelope (OGREnvelope *psEnvelope) const
virtual double | get_Length () const
virtual void | StartPoint (OGRPoint *) const
virtual void | EndPoint (OGRPoint *) const
virtual void | Value (double, OGRPoint *) const
int | getNumPoints () const
void | getPoint (int, OGRPoint *) const
double | getX (int i) const
double | getY (int i) const
double | getZ (int i) const
virtual OGRBoolean | Equals (OGRGeometry *) const
virtual void | setCoordinateDimension (int nDimension)
void | setNumPoints (int)
void | setPoint (int, OGRPoint *)
void | setPoint (int, double, double, double)
void | setPoints (int, OGRRawPoint *, double *=NULL)
void | setPoints (int, double *padfX, double *padfY, double *padfZ=NULL)
void | addPoint (OGRPoint *)
void | addPoint (double, double, double)
void | getPoints (OGRRawPoint *, double *=NULL) const
void | addSubLineString (const OGRLineString *, int nStartVertex=0, int nEndVertex=-1)
virtual OGRwkbGeometryType | getGeometryType () const
virtual const char * | getGeometryName () const
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)
virtual void | flattenTo2D ()

## Detailed Description

Concrete representation of a multi-vertex line.

## Constructor & Destructor Documentation

OGRLineString::OGRLineString | ( |  | ) |

| Create an empty line string.

## Member Function Documentation

void OGRLineString::addPoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |

  | Add a point to a line string. The vertex count of the line string is increased by one, and assigned from the passed location value. There is no SFCOM analog to this method. Parameters:
  | x | the X coordinate to assign to the new point.
  | y | the Y coordinate to assign to the new point.
  | z | the Z coordinate to assign to the new point (defaults to zero).

void OGRLineString::addPoint | ( | OGRPoint * | poPoint | ) |

  | Add a point to a line string. The vertex count of the line string is increased by one, and assigned from the passed location value. There is no SFCOM analog to this method. Parameters:
  | poPoint | the point to assign to the new vertex.

void OGRLineString::addSubLineString | ( | const OGRLineString * | poOtherLine,
|  | int | nStartVertex = `0`,
|  | int | nEndVertex = `-1`
| ) |

  | Add a segment of another linestring to this one. Adds the request range of vertices to the end of this line string in an efficient manner. If the nStartVertex is larger than the nEndVertex then the vertices will be reversed as they are copied. Parameters:
  | poOtherLine | the other OGRLineString.
  | nStartVertex | the first vertex to copy, defaults to 0 to start with the first vertex in the other linestring.
  | nEndVertex | the last vertex to copy, defaults to -1 indicating the last vertex of the other line string.

OGRGeometry * OGRLineString::clone | ( |  | ) | const`[virtual]`

| Make a copy of this object. This method relates to the SFCOM IGeometry::clone() method. This method is the same as the C function OGR_G_Clone(). Returns: a new object instance with the same geometry, and spatial reference system as the original. Implements OGRGeometry. Reimplemented in OGRLinearRing.

void OGRLineString::empty | ( |  | ) | `[virtual]`

| Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry. This method relates to the SFCOM IGeometry::Empty() method. This method is the same as the C function OGR_G_Empty(). Implements OGRGeometry.

void OGRLineString::EndPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

  | Return the curve end point. This method relates to the SF COM ICurve::get_EndPoint() method. Parameters:
  | poPoint | the point to be assigned the end location.
Implements OGRCurve.

OGRBoolean OGRLineString::Equals | ( | OGRGeometry * | poOther | ) | const`[virtual]`

| Returns two if two geometries are equivalent. This method is the same as the C function OGR_G_Equal(). Returns: TRUE if equivalent or FALSE otherwise. Implements OGRGeometry.

OGRErr OGRLineString::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData
| ) | const`[virtual]`

  | Convert a geometry into well known binary format. This method relates to the SFCOM IWks::ExportToWKB() method. This method is the same as the C function OGR_G_ExportToWkb(). Parameters:
  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
Returns: Currently OGRERR_NONE is always returned. Implements OGRGeometry. Reimplemented in OGRLinearRing.

OGRErr OGRLineString::exportToWkt | ( | char ** | ppszDstText | ) | const`[virtual]`

  | Convert a geometry into well known text format. This method relates to the SFCOM IWks::ExportToWKT() method. This method is the same as the C function OGR_G_ExportToWkt(). Parameters:
  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer.
Returns: Currently OGRERR_NONE is always returned. Implements OGRGeometry.

void OGRLineString::flattenTo2D | ( |  | ) | `[virtual]`

| Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0. This method is the same as the C function OGR_G_FlattenTo2D(). Implements OGRGeometry.

double OGRLineString::get_Length | ( |  | ) | const`[virtual]`

| Returns the length of the curve. This method relates to the SFCOM ICurve::get_Length() method. Returns: the length of the curve, zero if the curve hasn't been initialized. Implements OGRCurve.

int OGRLineString::getDimension | ( |  | ) | const`[virtual]`

| Get the dimension of this object. This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()). This method is the same as the C function OGR_G_GetDimension(). Returns: 0 for points, 1 for lines and 2 for surfaces. Implements OGRGeometry.

void OGRLineString::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[virtual]`

  | Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. This method is the same as the C function OGR_G_GetEnvelope(). Parameters:
  | psEnvelope | the structure in which to place the results.
Implements OGRGeometry.

const char * OGRLineString::getGeometryName | ( |  | ) | const`[virtual]`

| Fetch WKT name for geometry type. There is no SFCOM analog to this method. This method is the same as the C function OGR_G_GetGeometryName(). Returns: name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed. Implements OGRGeometry. Reimplemented in OGRLinearRing.

OGRwkbGeometryType OGRLineString::getGeometryType | ( |  | ) | const`[virtual]`

| Fetch geometry type. Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result. This method is the same as the C function OGR_G_GetGeometryType(). Returns: the geometry type code. Implements OGRGeometry.

int OGRLineString::getNumPoints | ( |  | ) | const`[inline]`

| Fetch vertex count. Returns the number of vertices in the line string. Returns: vertex count.

void OGRLineString::getPoint | ( | int | i,
|  | OGRPoint * | poPoint
| ) | const

  | Fetch a point in line string. This method relates to the SFCOM ILineString::get_Point() method. Parameters:
  | i | the vertex to fetch, from 0 to getNumPoints()-1.
  | poPoint | a point to initialize with the fetched point.

void OGRLineString::getPoints | ( | OGRRawPoint * | paoPointsOut,
|  | double * | padfZ = `NULL`
| ) | const

  | Returns all points of line string. This method copies all points into user list. This list must be at least sizeof(OGRRawPoint) * OGRGeometry::getNumPoints() byte in size. It also copies all Z coordinates. There is no SFCOM analog to this method. Parameters:
  | paoPointsOut | a buffer into which the points is written.
  | padfZ | the Z values that go with the points (optional, may be NULL).

double OGRLineString::getX | ( | int | iVertex | ) | const`[inline]`

  | Get X at vertex. Returns the X value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed. Parameters:
  | iVertex | the vertex to return, between 0 and getNumPoints()-1.
Returns: X value.

double OGRLineString::getY | ( | int | iVertex | ) | const`[inline]`

  | Get Y at vertex. Returns the Y value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed. Parameters:
  | iVertex | the vertex to return, between 0 and getNumPoints()-1.
Returns: X value.

double OGRLineString::getZ | ( | int | iVertex | ) | const

  | Get Z at vertex. Returns the Z (elevation) value at the indicated vertex. If no Z value is available, 0.0 is returned. If iVertex is out of range a crash may occur, no internal range checking is performed. Parameters:
  | iVertex | the vertex to return, between 0 and getNumPoints()-1.
Returns: Z value.

OGRErr OGRLineString::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`
| ) | `[virtual]`

  | Assign geometry from well known binary data. The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code. This method relates to the SFCOM IWks::ImportFromWKB() method. This method is the same as the C function OGR_G_ImportFromWkb(). Parameters:
  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
Returns: OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned. Implements OGRGeometry. Reimplemented in OGRLinearRing.

OGRErr OGRLineString::importFromWkt | ( | char ** | ppszInput | ) | `[virtual]`

  | Assign geometry from well known text data. The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code. This method relates to the SFCOM IWks::ImportFromWKT() method. This method is the same as the C function OGR_G_ImportFromWkt(). Parameters:
  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.
Returns: OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned. Implements OGRGeometry.

void OGRLineString::setCoordinateDimension | ( | int | nDimension | ) | `[virtual]`

  | Set the coordinate dimension. This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries. Parameters:
  | nNewDimension | New coordinate dimension value, either 2 or 3.
Reimplemented from OGRGeometry.

void OGRLineString::setNumPoints | ( | int | nNewPointCount | ) |

  | Set number of points in geometry. This method primary exists to preset the number of points in a linestring geometry before setPoint() is used to assign them to avoid reallocating the array larger with each call to addPoint(). This method has no SFCOM analog. Parameters:
  | nNewPointCount | the new number of points for geometry.

void OGRLineString::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | zIn
| ) |

  | Set the location of a vertex in line string. If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accomodate the request. There is no SFCOM analog to this method. Parameters:
  | iPoint | the index of the vertex to assign (zero based).
  | xIn | input X coordinate to assign.
  | yIn | input Y coordinate to assign.
  | zIn | input Z coordinate to assign (defaults to zero).

void OGRLineString::setPoint | ( | int | iPoint,
|  | OGRPoint * | poPoint
| ) |

  | Set the location of a vertex in line string. If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accomodate the request. There is no SFCOM analog to this method. Parameters:
  | iPoint | the index of the vertex to assign (zero based).
  | poPoint | the value to assign to the vertex.

void OGRLineString::setPoints | ( | int | nPointsIn,
|  | double * | padfX,
|  | double * | padfY,
|  | double * | padfZ = `NULL`
| ) |

  | Assign all points in a line string. This method clear any existing points assigned to this line string, and assigns a whole new set. There is no SFCOM analog to this method. Parameters:
  | nPointsIn | number of points being passed in padfX and padfY.
  | padfX | list of X coordinates of points being assigned.
  | padfY | list of Y coordinates of points being assigned.
  | padfZ | list of Z coordinates of points being assigned (defaults to NULL for 2D objects).

void OGRLineString::setPoints | ( | int | nPointsIn,
|  | OGRRawPoint * | paoPointsIn,
|  | double * | padfZ = `NULL`
| ) |

  | Assign all points in a line string. This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string. There is no SFCOM analog to this method. Parameters:
  | nPointsIn | number of points being passed in paoPointsIn
  | paoPointsIn | list of points being assigned.
  | padfZ | the Z values that go with the points (optional, may be NULL).

void OGRLineString::StartPoint | ( | OGRPoint * | poPoint | ) | const`[virtual]`

  | Return the curve start point. This method relates to the SF COM ICurve::get_StartPoint() method. Parameters:
  | poPoint | the point to be assigned the start location.
Implements OGRCurve.

OGRErr OGRLineString::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[virtual]`

  | Apply arbitrary coordinate transformation to geometry. This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units. Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry. This method is the same as the C function OGR_G_Transform(). Parameters:
  | poCT | the transformation to apply.
Returns: OGRERR_NONE on success or an error code. Implements OGRGeometry.

void OGRLineString::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint
| ) | const`[virtual]`

  | Fetch point at given distance along curve. This method relates to the SF COM ICurve::get_Value() method. Parameters:
  | dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  | poPoint | the point to be assigned the curve position.
Implements OGRCurve.

int OGRLineString::WkbSize | ( |  | ) | const`[virtual]`

| Returns size of related binary representation. This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries. This method relates to the SFCOM IWks::WkbSize() method. This method is the same as the C function OGR_G_WkbSize(). Returns: size of binary representation in bytes. Implements OGRGeometry. Reimplemented in OGRLinearRing.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrlinestring.cpp

Generated for GDAL by 1.4.5.